icn3d
=====

"I see in 3D" (iCn3D) Structure Viewer is a WebGL-based 3D viewer using Three.js and jQuery. iCn3D synchronizes the display of 3D structure, 2D interaction, and 1D sequences and annotations. Users' custom display can be saved in a short URL or a PNG image. More features are listed at [iCn3D Doc](https://www.ncbi.nlm.nih.gov/Structure/icn3d/icn3d.html#about).

Installation
------------

iCn3D can be installed with the following command:

    npm install icn3d

The following packages are required as shown in dependency:

    npm install jquery
    npm install jsdom
    npm install three

Usage
--------

* <b>Use icn3d as 3D Viewer</b>

    To show a 3D structure in a web page, you can following the instruction at [iCn3D Doc](https://www.ncbi.nlm.nih.gov/Structure/icn3d/icn3d.html#HowToUse). The JavaScript code could be as simple as the following:
    
    	var cfg = {'mmdbid': '1tup'};
    	var icn3dui = new icn3d.iCn3DUI(cfg);
    	icn3dui.show3DStructure();

* <b>Use icn3d to generate Node.js scripts</b>
    
    As shown in [one example of Node.js script](https://github.com/ncbi/icn3d/blob/master/icn3dnode/interaction2.js), part of the script can be like the following. All classes and functions can be accessed with the variable "icn3dui". The class structure is listed at [iCn3D Doc](https://www.ncbi.nlm.nih.gov/Structure/icn3d/icn3d.html#classstructure).
    
    	global.THREE = require('three');
    	let jsdom = require('jsdom');
    	global.$ = require('jquery')(new jsdom.JSDOM().window);
    	
    	let icn3d = require('icn3d');
    	let icn3dui = new icn3d.iCn3DUI({});

